Index: drivers/filesystems/btrfs/create.c
===================================================================
--- drivers/filesystems/btrfs/create.c	(révision 75772)
+++ drivers/filesystems/btrfs/create.c	(copie de travail)
@@ -777,7 +508,7 @@
             ExFreePool(dc);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         Status = RtlUTF8ToUnicodeN(dc->name.Buffer, utf16len, &utf16len, di->name, di->n);
         if (!NT_SUCCESS(Status)) {
             ERR("RtlUTF8ToUnicodeN 2 returned %08x\n", Status);
@@ -786,7 +517,7 @@
             ExFreePool(dc);
             goto cont;
         }
-        
+
         Status = RtlUpcaseUnicodeString(&dc->name_uc, &dc->name, TRUE);
         if (!NT_SUCCESS(Status)) {
             ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
@@ -795,183 +526,207 @@
             ExFreePool(dc);
             goto cont;
         }
-        
+
         dc->hash = calc_crc32c(0xffffffff, (UINT8*)dc->name.Buffer, dc->name.Length);
         dc->hash_uc = calc_crc32c(0xffffffff, (UINT8*)dc->name_uc.Buffer, dc->name_uc.Length);
-        
+
         InsertTailList(&fcb->dir_children_index, &dc->list_entry_index);
-        
+
         insert_dir_child_into_hash_lists(fcb, dc);
-        
+
+        num_children++;
+
 cont:
-        if (find_next_item(fcb->Vcb, &tp, &next_tp, FALSE, Irp))
+        if (find_next_item(Vcb, &tp, &next_tp, FALSE, Irp))
             tp = next_tp;
         else
             break;
     }
-    
+
+    // If a directory has a lot of files, force it to stick around until the next flush
+    // so we aren't constantly re-reading.
+    if (num_children >= 100)
+        mark_fcb_dirty(fcb);
+
     return STATUS_SUCCESS;
 }
 
-NTSTATUS open_fcb(device_extension* Vcb, root* subvol, UINT64 inode, UINT8 type, PANSI_STRING utf8, fcb* parent, fcb** pfcb, POOL_TYPE pooltype, PIRP Irp) {
+NTSTATUS open_fcb(_Requires_lock_held_(_Curr_->tree_lock) _Requires_exclusive_lock_held_(_Curr_->fcb_lock) device_extension* Vcb,
+                  root* subvol, UINT64 inode, UINT8 type, PANSI_STRING utf8, fcb* parent, fcb** pfcb, POOL_TYPE pooltype, PIRP Irp) {
     KEY searchkey;
     traverse_ptr tp, next_tp;
     NTSTATUS Status;
-    fcb* fcb;
+    fcb *fcb, *deleted_fcb = NULL;
     BOOL atts_set = FALSE, sd_set = FALSE, no_data;
     LIST_ENTRY* lastle = NULL;
     EXTENT_DATA* ed = NULL;
-    
+
     if (!IsListEmpty(&subvol->fcbs)) {
         LIST_ENTRY* le = subvol->fcbs.Flink;
-                                
+
         while (le != &subvol->fcbs) {
             fcb = CONTAINING_RECORD(le, struct _fcb, list_entry);
-            
+
             if (fcb->inode == inode) {
                 if (!fcb->ads) {
+                    if (fcb->deleted)
+                        deleted_fcb = fcb;
+                    else {
 #ifdef DEBUG_FCB_REFCOUNTS
-                    LONG rc = InterlockedIncrement(&fcb->refcount);
+                        LONG rc = InterlockedIncrement(&fcb->refcount);
 
-                    WARN("fcb %p: refcount now %i (subvol %llx, inode %llx)\n", fcb, rc, fcb->subvol->id, fcb->inode);
+                        WARN("fcb %p: refcount now %i (subvol %llx, inode %llx)\n", fcb, rc, fcb->subvol->id, fcb->inode);
 #else
-                    InterlockedIncrement(&fcb->refcount);
+                        InterlockedIncrement(&fcb->refcount);
 #endif
 
-                    *pfcb = fcb;
+                        *pfcb = fcb;
+                        return STATUS_SUCCESS;
+                    }
+                }
+            } else if (fcb->inode > inode) {
+                if (deleted_fcb) {
+                    InterlockedIncrement(&deleted_fcb->refcount);
+                    *pfcb = deleted_fcb;
                     return STATUS_SUCCESS;
                 }
-            } else if (fcb->inode > inode) {
+
                 lastle = le->Blink;
                 break;
             }
-            
+
             le = le->Flink;
         }
     }
-    
-    fcb = create_fcb(pooltype);
+
+    if (deleted_fcb) {
+        InterlockedIncrement(&deleted_fcb->refcount);
+        *pfcb = deleted_fcb;
+        return STATUS_SUCCESS;
+    }
+
+    fcb = create_fcb(Vcb, pooltype);
     if (!fcb) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     fcb->Vcb = Vcb;
-    
+
     fcb->subvol = subvol;
     fcb->inode = inode;
     fcb->type = type;
-    
+
     searchkey.obj_id = inode;
     searchkey.obj_type = TYPE_INODE_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, subvol, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
-        free_fcb(fcb);
+        free_fcb(Vcb, fcb);
         return Status;
     }
-    
+
     if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
         WARN("couldn't find INODE_ITEM for inode %llx in subvol %llx\n", inode, subvol->id);
-        free_fcb(fcb);
+        free_fcb(Vcb, fcb);
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     if (tp.item->size > 0)
         RtlCopyMemory(&fcb->inode_item, tp.item->data, min(sizeof(INODE_ITEM), tp.item->size));
-    
+
     if (fcb->type == 0) { // guess the type from the inode mode, if the caller doesn't know already
-        if (fcb->inode_item.st_mode & __S_IFDIR)
+        if ((fcb->inode_item.st_mode & __S_IFDIR) == __S_IFDIR)
             fcb->type = BTRFS_TYPE_DIRECTORY;
-        else if (fcb->inode_item.st_mode & __S_IFCHR)
+        else if ((fcb->inode_item.st_mode & __S_IFCHR) == __S_IFCHR)
             fcb->type = BTRFS_TYPE_CHARDEV;
-        else if (fcb->inode_item.st_mode & __S_IFBLK)
+        else if ((fcb->inode_item.st_mode & __S_IFBLK) == __S_IFBLK)
             fcb->type = BTRFS_TYPE_BLOCKDEV;
-        else if (fcb->inode_item.st_mode & __S_IFIFO)
+        else if ((fcb->inode_item.st_mode & __S_IFIFO) == __S_IFIFO)
             fcb->type = BTRFS_TYPE_FIFO;
-        else if (fcb->inode_item.st_mode & __S_IFLNK)
+        else if ((fcb->inode_item.st_mode & __S_IFLNK) == __S_IFLNK)
             fcb->type = BTRFS_TYPE_SYMLINK;
-        else if (fcb->inode_item.st_mode & __S_IFSOCK)
+        else if ((fcb->inode_item.st_mode & __S_IFSOCK) == __S_IFSOCK)
             fcb->type = BTRFS_TYPE_SOCKET;
         else
             fcb->type = BTRFS_TYPE_FILE;
     }
-    
+
     no_data = fcb->inode_item.st_size == 0 || (fcb->type != BTRFS_TYPE_FILE && fcb->type != BTRFS_TYPE_SYMLINK);
-    
+
     while (find_next_item(Vcb, &tp, &next_tp, FALSE, Irp)) {
         tp = next_tp;
-        
+
         if (tp.item->key.obj_id > inode)
             break;
-        
+
         if ((no_data && tp.item->key.obj_type > TYPE_XATTR_ITEM) || tp.item->key.obj_type > TYPE_EXTENT_DATA)
             break;
-        
+
         if (fcb->inode_item.st_nlink > 1 && tp.item->key.obj_type == TYPE_INODE_REF) {
             ULONG len;
             INODE_REF* ir;
-            
+
             len = tp.item->size;
             ir = (INODE_REF*)tp.item->data;
-            
+
             while (len >= sizeof(INODE_REF) - 1) {
                 hardlink* hl;
                 ULONG stringlen;
-                
+
                 hl = ExAllocatePoolWithTag(pooltype, sizeof(hardlink), ALLOC_TAG);
                 if (!hl) {
                     ERR("out of memory\n");
-                    free_fcb(fcb);
+                    free_fcb(Vcb, fcb);
                     return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
+
                 hl->parent = tp.item->key.offset;
                 hl->index = ir->index;
-                
+
                 hl->utf8.Length = hl->utf8.MaximumLength = ir->n;
-                
+
                 if (hl->utf8.Length > 0) {
                     hl->utf8.Buffer = ExAllocatePoolWithTag(pooltype, hl->utf8.MaximumLength, ALLOC_TAG);
                     RtlCopyMemory(hl->utf8.Buffer, ir->name, ir->n);
                 }
-                
+
                 Status = RtlUTF8ToUnicodeN(NULL, 0, &stringlen, ir->name, ir->n);
                 if (!NT_SUCCESS(Status)) {
                     ERR("RtlUTF8ToUnicodeN 1 returned %08x\n", Status);
                     ExFreePool(hl);
-                    free_fcb(fcb);
+                    free_fcb(Vcb, fcb);
                     return Status;
                 }
-                
-                hl->name.Length = hl->name.MaximumLength = stringlen;
-                
+
+                hl->name.Length = hl->name.MaximumLength = (UINT16)stringlen;
+
                 if (stringlen == 0)
                     hl->name.Buffer = NULL;
                 else {
                     hl->name.Buffer = ExAllocatePoolWithTag(pooltype, hl->name.MaximumLength, ALLOC_TAG);
-                    
+
                     if (!hl->name.Buffer) {
                         ERR("out of memory\n");
                         ExFreePool(hl);
-                        free_fcb(fcb);
+                        free_fcb(Vcb, fcb);
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
+
                     Status = RtlUTF8ToUnicodeN(hl->name.Buffer, stringlen, &stringlen, ir->name, ir->n);
                     if (!NT_SUCCESS(Status)) {
                         ERR("RtlUTF8ToUnicodeN 2 returned %08x\n", Status);
                         ExFreePool(hl->name.Buffer);
                         ExFreePool(hl);
-                        free_fcb(fcb);
+                        free_fcb(Vcb, fcb);
                         return Status;
                     }
                 }
-                
+
                 InsertTailList(&fcb->hardlinks, &hl->list_entry);
-                
+
                 len -= sizeof(INODE_REF) - 1 + ir->n;
                 ir = (INODE_REF*)&ir->name[ir->n];
             }
@@ -978,231 +733,336 @@
         } else if (fcb->inode_item.st_nlink > 1 && tp.item->key.obj_type == TYPE_INODE_EXTREF) {
             ULONG len;
             INODE_EXTREF* ier;
-            
+
             len = tp.item->size;
             ier = (INODE_EXTREF*)tp.item->data;
-            
+
             while (len >= sizeof(INODE_EXTREF) - 1) {
                 hardlink* hl;
                 ULONG stringlen;
-                
+
                 hl = ExAllocatePoolWithTag(pooltype, sizeof(hardlink), ALLOC_TAG);
                 if (!hl) {
                     ERR("out of memory\n");
-                    free_fcb(fcb);
+                    free_fcb(Vcb, fcb);
                     return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
+
                 hl->parent = ier->dir;
                 hl->index = ier->index;
-                
+
                 hl->utf8.Length = hl->utf8.MaximumLength = ier->n;
-                
+
                 if (hl->utf8.Length > 0) {
                     hl->utf8.Buffer = ExAllocatePoolWithTag(pooltype, hl->utf8.MaximumLength, ALLOC_TAG);
                     RtlCopyMemory(hl->utf8.Buffer, ier->name, ier->n);
                 }
-                
+
                 Status = RtlUTF8ToUnicodeN(NULL, 0, &stringlen, ier->name, ier->n);
                 if (!NT_SUCCESS(Status)) {
                     ERR("RtlUTF8ToUnicodeN 1 returned %08x\n", Status);
                     ExFreePool(hl);
-                    free_fcb(fcb);
+                    free_fcb(Vcb, fcb);
                     return Status;
                 }
-                
-                hl->name.Length = hl->name.MaximumLength = stringlen;
-                
+
+                hl->name.Length = hl->name.MaximumLength = (UINT16)stringlen;
+
                 if (stringlen == 0)
                     hl->name.Buffer = NULL;
                 else {
                     hl->name.Buffer = ExAllocatePoolWithTag(pooltype, hl->name.MaximumLength, ALLOC_TAG);
-                    
+
                     if (!hl->name.Buffer) {
                         ERR("out of memory\n");
                         ExFreePool(hl);
-                        free_fcb(fcb);
+                        free_fcb(Vcb, fcb);
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
+
                     Status = RtlUTF8ToUnicodeN(hl->name.Buffer, stringlen, &stringlen, ier->name, ier->n);
                     if (!NT_SUCCESS(Status)) {
                         ERR("RtlUTF8ToUnicodeN 2 returned %08x\n", Status);
                         ExFreePool(hl->name.Buffer);
                         ExFreePool(hl);
-                        free_fcb(fcb);
+                        free_fcb(Vcb, fcb);
                         return Status;
                     }
                 }
-                
+
                 InsertTailList(&fcb->hardlinks, &hl->list_entry);
-                
+
                 len -= sizeof(INODE_EXTREF) - 1 + ier->n;
                 ier = (INODE_EXTREF*)&ier->name[ier->n];
             }
         } else if (tp.item->key.obj_type == TYPE_XATTR_ITEM) {
-            if (tp.item->size < sizeof(DIR_ITEM)) {
-                ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DIR_ITEM));
+            ULONG len;
+            DIR_ITEM* di;
+
+            static char xapref[] = "user.";
+
+            if (tp.item->size < offsetof(DIR_ITEM, name[0])) {
+                ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, offsetof(DIR_ITEM, name[0]));
                 continue;
             }
-            
-            if (tp.item->key.offset == EA_REPARSE_HASH) {
-                UINT8* xattrdata;
-                UINT16 xattrlen;
-                
-                if (extract_xattr(tp.item->data, tp.item->size, EA_REPARSE, &xattrdata, &xattrlen)) {
-                    fcb->reparse_xattr.Buffer = (char*)xattrdata;
-                    fcb->reparse_xattr.Length = fcb->reparse_xattr.MaximumLength = xattrlen;
-                }
-            } else if (tp.item->key.offset == EA_EA_HASH) {
-                UINT8* eadata;
-                UINT16 ealen;
-                
-                if (extract_xattr(tp.item->data, tp.item->size, EA_EA, &eadata, &ealen)) {
-                    ULONG offset;
-                    
-                    Status = IoCheckEaBufferValidity((FILE_FULL_EA_INFORMATION*)eadata, ealen, &offset);
-                    
+
+            len = tp.item->size;
+            di = (DIR_ITEM*)tp.item->data;
+
+            do {
+                if (len < offsetof(DIR_ITEM, name[0]) + di->m + di->n)
+                    break;
+
+                if (tp.item->key.offset == EA_REPARSE_HASH && di->n == strlen(EA_REPARSE) && RtlCompareMemory(EA_REPARSE, di->name, di->n) == di->n) {
+                    if (di->m > 0) {
+                        fcb->reparse_xattr.Buffer = ExAllocatePoolWithTag(PagedPool, di->m, ALLOC_TAG);
+                        if (!fcb->reparse_xattr.Buffer) {
+                            ERR("out of memory\n");
+                            free_fcb(Vcb, fcb);
+                            return STATUS_INSUFFICIENT_RESOURCES;
+                        }
+
+                        RtlCopyMemory(fcb->reparse_xattr.Buffer, &di->name[di->n], di->m);
+                    } else
+                        fcb->reparse_xattr.Buffer = NULL;
+
+                    fcb->reparse_xattr.Length = fcb->reparse_xattr.MaximumLength = di->m;
+                } else if (tp.item->key.offset == EA_EA_HASH && di->n == strlen(EA_EA) && RtlCompareMemory(EA_EA, di->name, di->n) == di->n) {
+                    if (di->m > 0) {
+                        ULONG offset;
+
+                        Status = IoCheckEaBufferValidity((FILE_FULL_EA_INFORMATION*)&di->name[di->n], di->m, &offset);
+
+                        if (!NT_SUCCESS(Status))
+                            WARN("IoCheckEaBufferValidity returned %08x (error at offset %u)\n", Status, offset);
+                        else {
+                            FILE_FULL_EA_INFORMATION* eainfo;
+
+                            fcb->ea_xattr.Buffer = ExAllocatePoolWithTag(PagedPool, di->m, ALLOC_TAG);
+                            if (!fcb->ea_xattr.Buffer) {
+                                ERR("out of memory\n");
+                                free_fcb(Vcb, fcb);
+                                return STATUS_INSUFFICIENT_RESOURCES;
+                            }
+
+                            RtlCopyMemory(fcb->ea_xattr.Buffer, &di->name[di->n], di->m);
+
+                            fcb->ea_xattr.Length = fcb->ea_xattr.MaximumLength = di->m;
+
+                            fcb->ealen = 4;
+
+                            // calculate ealen
+                            eainfo = (FILE_FULL_EA_INFORMATION*)&di->name[di->n];
+                            do {
+                                fcb->ealen += 5 + eainfo->EaNameLength + eainfo->EaValueLength;
+
+                                if (eainfo->NextEntryOffset == 0)
+                                    break;
+
+                                eainfo = (FILE_FULL_EA_INFORMATION*)(((UINT8*)eainfo) + eainfo->NextEntryOffset);
+                            } while (TRUE);
+                        }
+                    }
+                } else if (tp.item->key.offset == EA_DOSATTRIB_HASH && di->n == strlen(EA_DOSATTRIB) && RtlCompareMemory(EA_DOSATTRIB, di->name, di->n) == di->n) {
+                    if (di->m > 0) {
+                        if (get_file_attributes_from_xattr(&di->name[di->n], di->m, &fcb->atts)) {
+                            atts_set = TRUE;
+
+                            if (fcb->type == BTRFS_TYPE_DIRECTORY)
+                                fcb->atts |= FILE_ATTRIBUTE_DIRECTORY;
+                            else if (fcb->type == BTRFS_TYPE_SYMLINK)
+                                fcb->atts |= FILE_ATTRIBUTE_REPARSE_POINT;
+
+                            if (fcb->type != BTRFS_TYPE_DIRECTORY)
+                                fcb->atts &= ~FILE_ATTRIBUTE_DIRECTORY;
+
+                            if (inode == SUBVOL_ROOT_INODE) {
+                                if (subvol->root_item.flags & BTRFS_SUBVOL_READONLY)
+                                    fcb->atts |= FILE_ATTRIBUTE_READONLY;
+                                else
+                                    fcb->atts &= ~FILE_ATTRIBUTE_READONLY;
+                            }
+                        }
+                    }
+                } else if (tp.item->key.offset == EA_NTACL_HASH && di->n == strlen(EA_NTACL) && RtlCompareMemory(EA_NTACL, di->name, di->n) == di->n) {
+                    if (di->m > 0) {
+                        fcb->sd = ExAllocatePoolWithTag(PagedPool, di->m, ALLOC_TAG);
+                        if (!fcb->sd) {
+                            ERR("out of memory\n");
+                            free_fcb(Vcb, fcb);
+                            return STATUS_INSUFFICIENT_RESOURCES;
+                        }
+
+                        RtlCopyMemory(fcb->sd, &di->name[di->n], di->m);
+
+                        // We have to test against our copy rather than the source, as RtlValidRelativeSecurityDescriptor
+                        // will fail if the ACLs aren't 32-bit aligned.
+                        if (!RtlValidRelativeSecurityDescriptor(fcb->sd, di->m, 0))
+                            ExFreePool(fcb->sd);
+                        else
+                            sd_set = TRUE;
+                    }
+                } else if (tp.item->key.offset == EA_PROP_COMPRESSION_HASH && di->n == strlen(EA_PROP_COMPRESSION) && RtlCompareMemory(EA_PROP_COMPRESSION, di->name, di->n) == di->n) {
+                    if (di->m > 0) {
+                        const char lzo[] = "lzo";
+                        const char zlib[] = "zlib";
+
+                        if (di->m == strlen(lzo) && RtlCompareMemory(&di->name[di->n], lzo, di->m) == di->m)
+                            fcb->prop_compression = PropCompression_LZO;
+                        else if (di->m == strlen(zlib) && RtlCompareMemory(&di->name[di->n], zlib, di->m) == di->m)
+                            fcb->prop_compression = PropCompression_Zlib;
+                        else
+                            fcb->prop_compression = PropCompression_None;
+                    }
+                } else if (di->n > strlen(xapref) && RtlCompareMemory(xapref, di->name, strlen(xapref)) == strlen(xapref)) {
+                    dir_child* dc;
+                    ULONG utf16len;
+
+                    Status = RtlUTF8ToUnicodeN(NULL, 0, &utf16len, &di->name[strlen(xapref)], di->n - (ULONG)strlen(xapref));
                     if (!NT_SUCCESS(Status)) {
-                        WARN("IoCheckEaBufferValidity returned %08x (error at offset %u)\n", Status, offset);
-                        ExFreePool(eadata);
-                    } else {
-                        FILE_FULL_EA_INFORMATION* eainfo;
-                        fcb->ea_xattr.Buffer = (char*)eadata;
-                        fcb->ea_xattr.Length = fcb->ea_xattr.MaximumLength = ealen;
-                        
-                        fcb->ealen = 4;
-                        
-                        // calculate ealen
-                        eainfo = (FILE_FULL_EA_INFORMATION*)eadata;
-                        do {
-                            fcb->ealen += 5 + eainfo->EaNameLength + eainfo->EaValueLength;
-                            
-                            if (eainfo->NextEntryOffset == 0)
-                                break;
-                            
-                            eainfo = (FILE_FULL_EA_INFORMATION*)(((UINT8*)eainfo) + eainfo->NextEntryOffset);
-                        } while (TRUE);
+                        ERR("RtlUTF8ToUnicodeN 1 returned %08x\n", Status);
+                        free_fcb(Vcb, fcb);
+                        return Status;
                     }
-                }
-            } else if (tp.item->key.offset == EA_DOSATTRIB_HASH) {
-                UINT8* xattrdata;
-                UINT16 xattrlen;
-                
-                if (extract_xattr(tp.item->data, tp.item->size, EA_DOSATTRIB, &xattrdata, &xattrlen)) {
-                    if (get_file_attributes_from_xattr((char*)xattrdata, xattrlen, &fcb->atts)) {
-                        atts_set = TRUE;
-                        
-                        if (fcb->type == BTRFS_TYPE_DIRECTORY)
-                            fcb->atts |= FILE_ATTRIBUTE_DIRECTORY;
-                        else if (fcb->type == BTRFS_TYPE_SYMLINK)
-                            fcb->atts |= FILE_ATTRIBUTE_REPARSE_POINT;
+
+                    dc = ExAllocatePoolWithTag(PagedPool, sizeof(dir_child), ALLOC_TAG);
+                    if (!dc) {
+                        ERR("out of memory\n");
+                        free_fcb(Vcb, fcb);
+                        return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
-                    ExFreePool(xattrdata);
+
+                    RtlZeroMemory(dc, sizeof(dir_child));
+
+                    dc->utf8.MaximumLength = dc->utf8.Length = di->n - (UINT16)strlen(xapref);
+                    dc->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, dc->utf8.MaximumLength, ALLOC_TAG);
+                    if (!dc->utf8.Buffer) {
+                        ERR("out of memory\n");
+                        ExFreePool(dc);
+                        free_fcb(Vcb, fcb);
+                        return STATUS_INSUFFICIENT_RESOURCES;
+                    }
+
+                    RtlCopyMemory(dc->utf8.Buffer, &di->name[strlen(xapref)], dc->utf8.Length);
+
+                    dc->name.MaximumLength = dc->name.Length = (UINT16)utf16len;
+                    dc->name.Buffer = ExAllocatePoolWithTag(PagedPool, dc->name.MaximumLength, ALLOC_TAG);
+                    if (!dc->name.Buffer) {
+                        ERR("out of memory\n");
+                        ExFreePool(dc->utf8.Buffer);
+                        ExFreePool(dc);
+                        free_fcb(Vcb, fcb);
+                        return STATUS_INSUFFICIENT_RESOURCES;
+                    }
+
+                    Status = RtlUTF8ToUnicodeN(dc->name.Buffer, utf16len, &utf16len, dc->utf8.Buffer, dc->utf8.Length);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("RtlUTF8ToUnicodeN 2 returned %08x\n", Status);
+                        ExFreePool(dc->utf8.Buffer);
+                        ExFreePool(dc->name.Buffer);
+                        ExFreePool(dc);
+                        free_fcb(Vcb, fcb);
+                        return Status;
+                    }
+
+                    Status = RtlUpcaseUnicodeString(&dc->name_uc, &dc->name, TRUE);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
+                        ExFreePool(dc->utf8.Buffer);
+                        ExFreePool(dc->name.Buffer);
+                        ExFreePool(dc);
+                        free_fcb(Vcb, fcb);
+                        return Status;
+                    }
+
+                    dc->size = di->m;
+
+                    InsertTailList(&fcb->dir_children_index, &dc->list_entry_index);
+                } else {
+                    xattr* xa;
+
+                    xa = ExAllocatePoolWithTag(PagedPool, offsetof(xattr, data[0]) + di->m + di->n, ALLOC_TAG);
+                    if (!xa) {
+                        ERR("out of memory\n");
+                        free_fcb(Vcb, fcb);
+                        return STATUS_INSUFFICIENT_RESOURCES;
+                    }
+
+                    xa->namelen = di->n;
+                    xa->valuelen = di->m;
+                    xa->dirty = FALSE;
+                    RtlCopyMemory(xa->data, di->name, di->m + di->n);
+
+                    InsertTailList(&fcb->xattrs, &xa->list_entry);
                 }
-            } else if (tp.item->key.offset == EA_NTACL_HASH) {
-                UINT16 buflen;
-                
-                if (extract_xattr(tp.item->data, tp.item->size, EA_NTACL, (UINT8**)&fcb->sd, &buflen)) {
-                    if (get_sd_from_xattr(fcb, buflen)) {
-                        sd_set = TRUE;
-                    } else
-                        ExFreePool(fcb->sd);
-                }
-            }
+
+                len -= (ULONG)offsetof(DIR_ITEM, name[0]) + di->m + di->n;
+
+                if (len < offsetof(DIR_ITEM, name[0]))
+                    break;
+
+                di = (DIR_ITEM*)&di->name[di->m + di->n];
+            } while (TRUE);
         } else if (tp.item->key.obj_type == TYPE_EXTENT_DATA) {
             extent* ext;
             BOOL unique = FALSE;
-            
+
             ed = (EXTENT_DATA*)tp.item->data;
-            
+
             if (tp.item->size < sizeof(EXTENT_DATA)) {
-                ERR("(%llx,%x,%llx) was %llx bytes, expected at least %llx\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset,
+                ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset,
                     tp.item->size, sizeof(EXTENT_DATA));
-                
-                free_fcb(fcb);
+
+                free_fcb(Vcb, fcb);
                 return STATUS_INTERNAL_ERROR;
             }
-            
+
             if (ed->type == EXTENT_TYPE_REGULAR || ed->type == EXTENT_TYPE_PREALLOC) {
                 EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ed->data[0];
-                
+
                 if (tp.item->size < sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2)) {
-                    ERR("(%llx,%x,%llx) was %llx bytes, expected at least %llx\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset,
+                    ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset,
                         tp.item->size, sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2));
-                
-                    free_fcb(fcb);
+
+                    free_fcb(Vcb, fcb);
                     return STATUS_INTERNAL_ERROR;
                 }
-                
-                if (ed2->address == 0 && ed2->size == 0) // sparse
+
+                if (ed2->address == 0 || ed2->size == 0) // sparse
                     continue;
-                
+
                 if (ed2->size != 0 && is_tree_unique(Vcb, tp.tree, Irp))
                     unique = is_extent_unique(Vcb, ed2->address, ed2->size, Irp);
             }
-            
-            ext = ExAllocatePoolWithTag(pooltype, sizeof(extent), ALLOC_TAG);
+
+            ext = ExAllocatePoolWithTag(pooltype, offsetof(extent, extent_data) + tp.item->size, ALLOC_TAG);
             if (!ext) {
                 ERR("out of memory\n");
-                free_fcb(fcb);
+                free_fcb(Vcb, fcb);
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
-            ext->data = ExAllocatePoolWithTag(pooltype, tp.item->size, ALLOC_TAG);
-            if (!ext->data) {
-                ERR("out of memory\n");
-                ExFreePool(ext);
-                free_fcb(fcb);
-                return STATUS_INSUFFICIENT_RESOURCES;
-            }
-            
+
             ext->offset = tp.item->key.offset;
-            RtlCopyMemory(ext->data, tp.item->data, tp.item->size);
+            RtlCopyMemory(&ext->extent_data, tp.item->data, tp.item->size);
             ext->datalen = tp.item->size;
             ext->unique = unique;
             ext->ignore = FALSE;
             ext->inserted = FALSE;
-            
-            if (ed->type == EXTENT_TYPE_REGULAR && !(fcb->inode_item.flags & BTRFS_INODE_NODATASUM)) {
-                EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ed->data[0];
-                UINT64 len;
-                
-                len = (ed->compression == BTRFS_COMPRESSION_NONE ? ed2->num_bytes : ed2->size) / Vcb->superblock.sector_size;
-                
-                ext->csum = ExAllocatePoolWithTag(NonPagedPool, len * sizeof(UINT32), ALLOC_TAG);
-                if (!ext->csum) {
-                    ERR("out of memory\n");
-                    ExFreePool(ext);
-                    free_fcb(fcb);
-                    return STATUS_INSUFFICIENT_RESOURCES;
-                }
-                
-                Status = load_csum(Vcb, ext->csum, ed2->address + (ed->compression == BTRFS_COMPRESSION_NONE ? ed2->offset : 0), len, Irp);
-                
-                if (!NT_SUCCESS(Status)) {
-                    ERR("load_csum returned %08x\n", Status);
-                    ExFreePool(ext);
-                    free_fcb(fcb);
-                    return Status;
-                }
-            } else
-                ext->csum = NULL;
-            
+            ext->csum = NULL;
+
             InsertTailList(&fcb->extents, &ext->list_entry);
         }
     }
-    
+
     if (fcb->type == BTRFS_TYPE_DIRECTORY) {
-        Status = load_dir_children(fcb, FALSE, Irp);
+        Status = load_dir_children(Vcb, fcb, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("load_dir_children returned %08x\n", Status);
-            free_fcb(fcb);
+            free_fcb(Vcb, fcb);
             return Status;
         }
     }
-    
+
     if (no_data) {
         fcb->Header.AllocationSize.QuadPart = 0;
         fcb->Header.FileSize.QuadPart = 0;
